datablock AudioProfile(R_P90SoundTail)
{
   filename    = "./sounds/smg_P90_tail.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(R_P90SoundLoop)
{
   filename    = "./sounds/smg_P90_loop.wav";
   description = AudioDefaultLooping3d;
   preload = true;
   
   tailDB = R_P90SoundTail;
};

datablock DebrisData(R_P90MagDebris)
{
	shapeFile = "./shapes/debris/P90mag.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ItemData(R_P90Item)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./shapes/P90/P90.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Submachine Gun Compact";
	iconName = "./icon_gun";
	doColorShift = true;
	colorShiftColor = $GlobalColorShift;

	 // Dynamic properties defined by the scripts
	image = R_P90Image;
	canDrop = true;
};

$RWep_MagazineMax["P90"] = 2;
$RWep_MagazineName["P90"] = "P90";
datablock ShapeBaseImageData(R_P90Image)
{
	R_Reloadable = true;
	R_MagSize = 50;
	R_AmmoName = "P90";
	R_AmmoType = "Low Power";
	R_TriggerReleasePenalty = true;
	
	R_FarShotSound = RDistSound_Pistol;
	R_WeaponLoopSound = R_P90SoundLoop;
	
	R_InheritImage = R_P90Image;
	R_UsesMagazines = true;
	spraySeed = 433987;

   // Basic Item properties
   shapeFile = "./shapes/P90/P90.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0.15 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = R_P90Item;
   ammo = " ";
   projectile = R_AssaultRifleProjectile;
   projectileType = Projectile;

	casing = R_AssaultRifleShellDebris;
	shellExitDir        = "0 -0.25 -1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = R_P90Item.colorShiftColor;//"0.400 0.196 0 1.000";

	R_ADSImage = R_P90AimingImage;
	R_ReloadImage = R_P90ReloadingImage;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSequence[0]				= "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreAmmoCheck";
	stateAllowImageChange[1]         = true;
	stateSequence[1]					= "Ready";
	stateScript[1]					= "onReady";
	stateTransitionOnNoAmmo[1]		= "PreAmmoCheck";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.06;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= R_SubmachineGunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= "";
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= R_SubmachineGunSmokeEmitter;
	stateEmitterTime[3]				= 0.075;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.00;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]					= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]   = "Ready";
	stateTransitionOnTriggerDown[4]   = "PreAmmoCheck";
	stateSequence[4]				= "Ready";
	
	stateName[5]					= "PreAmmoCheck";
	stateScript[5]					= "onPreAmmoCheck";
	stateTransitionOnTimeout[5]		= "AmmoCheck";
	
	stateName[6]					= "AmmoCheck";
	stateTransitionOnAmmo[6]		= "Fire";
	stateTransitionOnNoAmmo[6]		= "Dryfire";
	
	stateName[7]					= "Dryfire";
	stateScript[7]					= "onDryFire";
	stateTransitionOnTriggerUp[7]	= "Ready";
	stateTimeoutValue[7]			= 0.1;
	
	// climbModifier = 0.7;
	// maxClimb = 0.25;
	// boundModifier = 1;
	// maxBound = 9;
	
	resetTime 		= 256;
	
	recoilAnimationPoint = 4;
	
	screenShakeModifier = 0.05;
	screenShakeMin = 0.10;
	screenShakeMax = 0.55;
	
	climbModifier = 0.85;
	boundModifier = 0.6;

};

datablock ShapeBaseImageData(R_P90AimingImage : R_P90Image)
{
	rotation = eulerToMatrix( vectorAdd( "0 0 0", $Pref::RallyPack::ADSRollVector ) ); 
	
   shapeFile = "./shapes/P90/P90.dts";
  	
   offset = "0 0.15 0";
	eyeOffset = "0.0 0.2 -0.75925";
	R_ADSImage = R_P90Image;
	
	//R_AmmoType = "Low Power";
	
	climbModifier = $IronsightsDefaultClimbMod;
	boundModifier = $IronsightsDefaultBoundMod;
	forceZoomFOV = $IronsightsFov;
	R_MovePenalty = $IronsightsMovePenalty;

};

datablock ShapeBaseImageData(R_P90ReloadingImage)
{
	R_InheritImage = R_P90Image;
   shapeFile = "./shapes/P90/P90.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0.15 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" ); 
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = R_P90Item;
   ammo = " ";
   projectile = R_AssaultRifleProjectile;
   projectileType = Projectile;

	casing = R_P90MagDebris;
	shellExitDir        = "0.0 -0.5 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;
	
   melee = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = R_P90Item.colorShiftColor;//"0.400 0.196 0 1.000";

	reloadTime0 = 2.15;
	reloadTime1 = 1.8;
	
	stateName[0]                    = "ReloadStart";
	stateTransitionOnTimeout[0]		= "MagOut";
	stateTimeoutValue[0]			= 0.15;
	
	stateName[1]                    = "MagOut";
	stateTransitionOnTimeout[1]		= "MagIn";
	stateEjectShell[1]       		= true;
	stateSequence[1]				= "nomag";
	stateScript[1]					= "onMagOut";
	stateTimeoutValue[1]			= 1.25;
	stateSound[1]					= R_SubmachineReload1Sound;
	
	stateName[2]                    = "MagIn";
	stateTransitionOnTimeout[2]		= "PreAmmoCheck";
	stateSequence[2]				= "ready";
	stateScript[2]					= "onMagIn";
	stateTimeoutValue[2]			= 0.25;
	stateSound[2]					= R_SubmachineReload2Sound;

	stateName[5]					= "PreAmmoCheck";
	stateScript[5]					= "onPreAmmoCheck";
	stateTransitionOnTimeout[5]		= "AmmoCheck";
	stateTimeoutValue[5]			= 0.1;
	
	stateName[6]					= "AmmoCheck";
	stateTransitionOnAmmo[6]		= "Finish";
	stateTransitionOnNoAmmo[6]		= "Charge";	

	stateName[3]                    = "Charge";
	stateTransitionOnTimeout[3]		= "Finish";
	stateSequence[3]				= "charge";
	stateScript[3]					= "onCharge";
	stateTimeoutValue[3]			= 0.25;
	stateSound[3]					= R_SubmachineReload3Sound;

	stateName[4]                    = "Finish";
	stateScript[4]					= "onReloadFinish";
};


function R_P90ReloadingImage::onMagOut(%this, %player, %slot)
{
	%player.playThread(2, wrench);
	%player.playThread(3, shiftTo);
}
function R_P90ReloadingImage::onMagIn(%this, %player, %slot)
{
	%player.playThread(2, shiftLeft);
	%player.playThread(3, plant);	
}
function R_P90ReloadingImage::onCharge(%this, %player, %slot){%player.playThread(2, shiftRight);}
function R_P90ReloadingImage::onReloadFinish(%this, %player, %slot){RWepMagazine_handleReload(%this, %player, %slot);}

function R_P90ReloadingImage::onPreAmmoCheck(%this, %player, %slot){RWep_reloadingAmmoCheck(%this, %player, %slot);}
function R_P90Image::onPreAmmoCheck(%this, %player, %slot){RWep_preAmmoCheck(%this, %player, %slot);}
//function R_P90AimingImage::onPreAmmoCheck(%this, %player, %slot){RWep_preAmmoCheck(%this, %player, %slot);}
function R_P90AimingImage::onPreAmmoCheck(%this, %player, %slot){RWep_preAmmoCheck(%this, %player, %slot);}


function R_P90Image::onFire(%this, %player, %slot, %ADS)
{
	RWepSim_handleWeaponFire(%this, %player, %slot);
	if(%player.RWepSim_shotnumber > 3)
	{
		%player.playThread(2 + %player.RWepSim_shotnumber % 2, jump);
	}
}
//function R_P90AimingImage::onFire(%this, %player, %slot){R_P90Image::onFire(%this, %player, %slot, true);}
function R_P90AimingImage::onFire(%this, %player, %slot){R_P90Image::onFire(%this, %player, %slot, true);}

function R_P90Image::onDryFire(%this, %player, %slot){RWep_DryFire(%this, %player, %slot);}
//function R_P90AimingImage::onDryFire(%this, %player, %slot){RWep_DryFire(%this, %player, %slot);}
function R_P90AimingImage::onDryFire(%this, %player, %slot){RWep_DryFire(%this, %player, %slot);}
function R_P90AimingImage::onSemiAutoActivate(%this, %player, %slot){%player.playThread(2, plant); serverPlay3D(R_SubmachineReload3Sound, %player.getPosition());}